using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Enums.SafetyEnums;
using VkNet.Model.Keyboard;
using VkNet.Model.RequestParams;
using System.Linq;
using SvetoforVKBot.Services;

namespace SvetoforVKBot.Models.Commands.Registration
{
    public class GetLoginCommand
    {
        public void Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            var chatId = update.@object.message.from_id;
            MessagesSendParams @params = new MessagesSendParams();
            var keyboardBuilder = new KeyboardBuilder().Clear();

            try
            {
                if (update.@object.message.text.Length > 0 && update.@object.message.text.Length <= 50)
                {
                    var ids = new long[] { chatId };
                    string login = update.@object.message.text.Trim();
                    string message = "";
                    var user = db.Users.Single(usr => usr.chatId == chatId);
                    string pincode = PasswordService.GeneratePassword();
                    string hash = PasswordService.CreateMD5(pincode + chatId.ToString());
                    message = $"Ваш код подтверждения: {pincode}";


                    keyboardBuilder
                            .AddButton("Отменить", "startPL", KeyboardButtonColor.Default);
                    @params.Keyboard = keyboardBuilder.Build();
                    @params.Message = "На Вашу корпоративную почту отправлено письмо с кодом подтверждения.\n" +
                        "Введите код в ответ на данное сообщение, чтобы завершить авторизацию.";
                    @params.UserId = chatId;
                    @params.RandomId = GetRandomId();
                    client.Messages.SendAsync(@params);

                    user.login = login;
                    user.password = hash;
                    user.tag = "Подписчик - Регистрация - Код";
                    db.SaveChanges();

                    EmailService emailService = new EmailService();
                    emailService.SendEmailAsync($"{login}@vyatsu.ru", "Код подтверждения", message);

                }
                else
                {
                    @params.Message = "Данные введены некорректно 😕 Напишите, пожалуйста, текст длиной до 50 символов.";
                    @params.UserId = chatId;
                    @params.RandomId = GetRandomId();
                    client.Messages.SendAsync(@params);
                }
            }
            catch (Exception ee)
            {
                @params.Message = "‼Ошибка в GetFIOCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
        }

        private static readonly RandomNumberGenerator Rng = RandomNumberGenerator.Create();
        public int GetRandomId()
        {
            var intBytes = new byte[4];

            Rng.GetBytes(intBytes);

            return BitConverter.ToInt32(intBytes, 0);
        }
    }
}